incorrect return values for get{First|Next|Last|Previous} methods

02/13/2015 07:38 AM - Ovidiu Maxiniuc

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee:  % Done: 100%

Category:  Estimated time: 0.00 hour

Target version:    

billable: No case_num:  

vendor_id: GCD version:  

Description

Related issues:

Related to Database - Bug #2625: query-off-end does not work properly Closed

History

#1 - 02/13/2015 07:46 AM - Ovidiu Maxiniuc

The set of get{First|Next|Last|Previous} methods should return:

? (unknown) if the query object handle is invalid;

yes if a new (virtual) row is found and available;

no if the query is not open or the next record cannot be found.

At this moment they return no if case of error conditions and yes otherwise (regardless if a new row is available or not). This means that if a procedure

uses them to end a loop, it will break when trying to access an inexistent off-end row of the query.

#2 - 02/13/2015 02:32 PM - Ovidiu Maxiniuc

Alternative working form for

IF (NOT qh:GET-NEXT())

   THEN ... 

is to rewrite as:

qh:GET-NEXT().

IF (qh:QUERY-OFF-END)

   THEN ...

This may give the fix solution to return in GET-NEXT the !QUERY-OFF-END.
#3 - 02/18/2015 02:41 PM - Ovidiu Maxiniuc

- File om_upd20150218b.zip added

This update should fix the return values for respective methods.

#4 - 11/19/2015 02:46 PM - Eric Faulhaber

- Status changed from New to Closed

- % Done changed from 0 to 100

Sorry, I just came across this issue and realized I never reviewed this update separately. However, it seems this fix went into the trunk as part of

revision 10904, so I am closing this issue.

Files

om_upd20150218b.zip 12.7 KB 02/18/2015 Ovidiu Maxiniuc
